/***************************************************************************
                          encoder.cpp  -  description
                             -------------------
    begin                : Wed Jul 19 2000
    copyright            : (C) 2000 by Christoph Maciejewski
    email                : macchristoph@yahoo.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kencfront.h"
#include "kencoder.h"
#include "pfadedit.h"
#include <qaccel.h>

//***************** Initialisiert den Prozess "blade" **********************

void kencfront::bladeInit(unsigned int pos)
{
   QString argus("-prio=");
   QString rate("-");

   int fall=0;

   blade->clearArguments();

   argus.append( PRIO->currentText() );
   rate.append( RATE->currentText() );


   Meldung->clear();
   Lcd->display(firstItem);

   if(CRC->isChecked())fall=1;
   if(MONO->isChecked())fall=2;
   if(DEL->isChecked())fall=3;
   if(SWAP->isChecked())fall=4;
   if(CRC->isChecked() && MONO->isChecked())fall=5;
   if(CRC->isChecked() && DEL->isChecked())fall=6;
   if(MONO->isChecked() && DEL->isChecked())fall=7;
   if(CRC->isChecked() && MONO->isChecked() && DEL->isChecked())fall=8;

   if(firstItem > 0)
   {

     switch(fall)
     {
         case 0:(*blade) << "bladeenc" << argus << "-refresh=10" << Quelle->text(pos) << Ziel->text(pos) << rate; break;
         case 1:(*blade) << "bladeenc" << argus << "-refresh=10" << Quelle->text(pos) << Ziel->text(pos) << rate << "-crc"; break;
         case 2:(*blade) << "bladeenc" << argus << "-refresh=10" << Quelle->text(pos) << Ziel->text(pos) << rate << "-mono"; break;
         case 3:(*blade) << "bladeenc" << argus << "-refresh=10" << Quelle->text(pos) << Ziel->text(pos) << rate << "-del"; break;
         case 4:(*blade) << "bladeenc" << argus << "-refresh=10" << Quelle->text(pos) << Ziel->text(pos) << rate << "-swap"; break;
         case 5:(*blade) << "bladeenc" << argus << "-refresh=10" << Quelle->text(pos) << Ziel->text(pos) << rate << "-crc" << "-mono"; break;
         case 6:(*blade) << "bladeenc" << argus << "-refresh=10" << Quelle->text(pos) << Ziel->text(pos) << rate << "-crc" << "-del"; break;
         case 7:(*blade) << "bladeenc" << argus << "-refresh=10" << Quelle->text(pos) << Ziel->text(pos) << rate << "-mono" << "-del"; break;
         case 8:(*blade) << "bladeenc" << argus << "-refresh=10" << Quelle->text(pos) << Ziel->text(pos) << rate << "-crc" << "-mono" << "-del"; break;
     }


  	 connect(blade, SIGNAL(receivedStdout(KProcess*, char*, int)),
					this, SLOT(uebergabe(KProcess*, char*, int)));
	
	   connect(blade, SIGNAL(receivedStderr(KProcess*, char*, int)),
					this, SLOT(uebergabe(KProcess*, char*, int)));
	
	   connect(blade, SIGNAL(processExited(KProcess*)), this, SLOT(bladeExit(KProcess*)));
	  }
	
}
//**************************************************************************

//**************** Startet oder beendet Prozess "blade" ********************

void kencfront::bladeRun()
{

       Quelle->setSelected ( position, TRUE );
       status->setText(i18n("luft..."));	
       QPushButton_3->setText(i18n("Stop!"));

       blade->start(KProcess::NotifyOnExit, KProcess::AllOutput);

       bearbeiten->changeItem ( *DELETE, i18n("Stopen"), 1);
       datei->setItemEnabled ( 1, FALSE );  //************************
       SWAP->setEnabled ( FALSE );
       CRC->setEnabled ( FALSE );
       Ziel->setEnabled ( FALSE );
       MONO->setEnabled ( FALSE );          //Funktionen deaktivieren
       RATE->setEnabled ( FALSE );
       Quelle->setEnabled ( FALSE );
       DEL->setEnabled ( FALSE );
       PRIO->setEnabled ( FALSE );
       Button_loesch->setEnabled ( FALSE );
       QPushButton_1->setEnabled ( FALSE );
       QPushButton_2->setEnabled ( FALSE ); //************************

}
//**************************************************************************

void kencfront::bladeKill()
{

        blade->kill(SIGTERM);
        Progress->reset();
        status->setText("Bereit...");
        QPushButton_3->setText(i18n("Start!"));
        bearbeiten->changeItem ( *TICK, i18n("Starten"), 1);
        datei->setItemEnabled ( 1, TRUE );
        SWAP->setEnabled ( TRUE );
        CRC->setEnabled ( TRUE );
        Ziel->setEnabled ( TRUE );
        MONO->setEnabled ( TRUE );
        RATE->setEnabled ( TRUE );
        Quelle->setEnabled ( TRUE );
        DEL->setEnabled ( TRUE );
        PRIO->setEnabled ( TRUE );
        Button_loesch->setEnabled ( TRUE );
        QPushButton_1->setEnabled ( TRUE );
        QPushButton_2->setEnabled ( TRUE );



}
//**************************************************************************













