/***************************************************************************
                          kencfront.cpp  -  description
                             -------------------
    begin                : Wed Jun 28 2000
    copyright            : (C) 2000 by Christoph Maciejewski
    email                : macchristoph@yahoo.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "kencfront.h"
#include "kencoder.h"
#include "pfadedit.h"
#include <qaccel.h>




kencfront::kencfront(QWidget *parent, const char *name) : QWidget(parent,name)
{
	initDialog();
	KDNDDropZone ( this, DndURL );
	
	// Initialisieren des Ausgangszustands**********************************
	//**********************************************************************
	//position = 0;
	firstItem = 0;
	startClicked = 0;
	Button_loesch->setEnabled ( FALSE );
	QPushButton_2->setEnabled ( FALSE );
	
	//*********************************************************************
	
	datei = new QPopupMenu();
	CHECK_PTR( datei );
	datei->insertItem( *OPEN, i18n("WAV-Datei hinzufgen"),  this, SLOT(open()), CTRL+Key_O, 1 );
	datei->insertSeparator();
	datei->insertItem( *EXIT, i18n("Programm Beenden"),  qApp, SLOT(quit()), CTRL+Key_E, 2 );
	
	bearbeiten = new QPopupMenu();
	CHECK_PTR( bearbeiten );
	bearbeiten->insertItem( *TICK, i18n("Starten "),  this, SLOT(buttonStart()), CTRL+Key_S, 1);
		
  hilfe = new QPopupMenu();
	CHECK_PTR( bearbeiten );
	hilfe->insertItem( *HELP, i18n("Hilfethemen"),  this, SLOT(help()), Key_F1 );
	hilfe->insertSeparator();
	hilfe->insertItem( i18n("ber KEncoder"), this, SLOT(abouti()) );
	
		
	menu = new KMenuBar( this );
	CHECK_PTR( menu );
	menu->insertItem( i18n("&Datei"), datei );
	menu->insertItem( i18n("&Encoder"), bearbeiten );
	menu->insertItem( i18n("&Hilfe"), hilfe );
	
	blade = new KProcess();
	
	// Verbinden der Objekte************************************************
	//**********************************************************************
	connect(QPushButton_3, SIGNAL(clicked()), this, SLOT(buttonStart()) );
	connect(QPushButton_1, SIGNAL(clicked()), this, SLOT(open()) );
	connect(QPushButton_2, SIGNAL(clicked()), this, SLOT(pfad()) );
	connect(MONO, SIGNAL(clicked()), this, SLOT(swap()) );
	connect(Quelle, SIGNAL(highlighted(int)), this, SLOT(marker(int)) );
	connect(Ziel, SIGNAL(highlighted(int)), this, SLOT(marker(int)) );
	connect(Ziel, SIGNAL(selected(int)), this, SLOT(pfad()) );
	connect(Button_loesch, SIGNAL(clicked()), this, SLOT(deletItem()) );
	//**********************************************************************
	
	
	//Drag'n'Drop untersttzung *************
	
	myDNDZone = new KDNDDropZone(Quelle, DndFile);
	connect(myDNDZone, SIGNAL(dropAction(KDNDDropZone*)), this, SLOT(dropAction(KDNDDropZone*)));
	
  //***************************************
}

kencfront::~kencfront()
{

}

//*******************************************************************************
//*********************** Wertet die vom blade gesendeten Signale aus ***********
//*******************************************************************************
void kencfront::uebergabe( KProcess *proc, char *buffer, int buflen)
{
  QString texts;
  QString prozent(buffer,16);
  long progres;
  unsigned int len;

  prozent = prozent.mid(10,2);
  progres = prozent.toLong();
  texts = buffer;
  texts.truncate(buflen);	
	len = texts.length();



  Meldung->clear();    //Meldungen lschen

  Meldung->setCursorPosition ( 0, 0 );
  Meldung->insertLine ( texts );
  Meldung->setCursorPosition ( 60, 3 );

  Progress->setProgress ( progres );

  //********* setzt delay wieder frei, siehe bladeExit(KProcess* prozess)********
  if(progres > 95)delay = 0;
  //musste rein, wegen des mehrfachen Exit-Signals. Nicht schn aber wirkungsvoll...

}
//*******************************************************************************

void kencfront::open()
{
  QString fileName = QFileDialog::getOpenFileName("/", "*.wav");
  if( strlen(fileName) > 3 )
   {
     Quelle->insertItem(fileName);
     status->setText(i18n("berprfen Sie die Dateinamen!"));
     fileName.replace((fileName.length())-4,4,".mp3");
	   Ziel->insertItem(fileName);
	   firstItem = firstItem+1;
	   Lcd->display(firstItem);
	   Button_loesch->setEnabled ( TRUE );
	   QPushButton_2->setEnabled ( TRUE );
	      	
   }

}

void kencfront::swap()
{
  if( MONO->isChecked() )
  {
    SWAP->setEnabled ( FALSE );
  }else SWAP->setEnabled ( TRUE );

}

void kencfront::abouti()
{
   info = new QMessageBox( i18n("ber"), i18n("KEncoder 0.2.1\n\nEin Programm zum Erzeugen von MP3-Files\nvon Christoph Maciejewski\nmacchristoph@yahoo.de"),
                           QMessageBox::Information,
                           0, 0, 0, this, "info");
   info->setIconPixmap(*INFO_LOGO);

   info->show();


}

void kencfront::help()
{
  kapp->invokeHTMLHelp("kencoder/index.html","");

}

void kencfront::marker(int index)
{
  Ziel->setCurrentItem(index);
  Quelle->setCurrentItem(index);

}

void kencfront::deletItem()
{
  int i=Quelle->currentItem();

  if(firstItem > 0 && (Quelle->currentItem() > -1))
    {
      Quelle->removeItem(i);
      Ziel->removeItem(i);

      firstItem = firstItem - 1;

      if(firstItem < 1)
        {
          Button_loesch->setEnabled ( FALSE );
          QPushButton_2->setEnabled ( FALSE );
        }

      Lcd->display(firstItem);
    }
}

void kencfront::insItem(QString url)
{
   Quelle->insertItem(url);
	 url.replace((url.length())-4,4,".mp3");
	 Ziel->insertItem(url);
	 Ziel->setSelected ( 0, TRUE );
	 firstItem = firstItem+1;
	 Lcd->display(firstItem);
	 Button_loesch->setEnabled ( TRUE );
	 QPushButton_2->setEnabled ( TRUE );
	
	 	
}

void kencfront::bladeExit(KProcess* prozess)
{
   int posi = position;
   QString anzahlJobs;

   anzahlJobs.setNum((Quelle->currentItem())+1);
   anzahlJobs.append(i18n(" Datei(en) wurden kodiert"));

   if((Quelle->count() > (position+1)) && delay == 0)
    {
       bladeKill();
       delay = 1;
       position++;
       Progress->reset();
       Lcd->display(posi+1);
       bladeInit(position);
       bladeRun();


    }

    status->setText(anzahlJobs);

}

//********************* Wenn Start gedrckt wird ********************

void kencfront::buttonStart()
{
  if(Quelle->count() > 0)
    {
       position = 0;
       bladeInit(0);
       if(Ziel->isEnabled()){bladeRun();}else bladeKill();
    }
}
//*******************************************************************

void kencfront::pfad()
{
   PfadEdit pfadedit;

   pfadedit.pfadLine->setText(Ziel->text(Ziel->currentItem()));
   pfadedit.setCaption( i18n("Speichern unter...") );
   pfadedit.show();
   Ziel->changeItem(pfadedit.pfadLine->text(), Ziel->currentItem());

}






































